// Generated by zig-wayland

// Copyright © 2017 Drew DeVault
// 
// Permission to use, copy, modify, distribute, and sell this
// software and its documentation for any purpose is hereby granted
// without fee, provided that the above copyright notice appear in
// all copies and that both that copyright notice and this permission
// notice appear in supporting documentation, and that the name of
// the copyright holders not be used in advertising or publicity
// pertaining to distribution of the software without specific,
// written prior permission.  The copyright holders make no
// representations about the suitability of this software for any
// purpose.  It is provided "as is" without express or implied
// warranty.
// 
// THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
// SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
// SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
// AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
// ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
// THIS SOFTWARE.
// 

const std = @import("std");
const os = std.os;
const client = @import("wayland.zig").client;
const common = @import("common.zig");pub const LayerShellV1 = opaque {
 pub const generated_version = 3;
 pub const getInterface = common.zwlr.layer_shell_v1.getInterface;pub const Error = common.zwlr.layer_shell_v1.Error;
pub const Layer = common.zwlr.layer_shell_v1.Layer;
pub fn setQueue(_layer_shell_v1: *LayerShellV1, _queue: *client.wl.EventQueue) void {
    const _proxy: *client.wl.Proxy = @ptrCast(_layer_shell_v1);
    _proxy.setQueue(_queue);
}pub fn getLayerSurface(_layer_shell_v1: *LayerShellV1, _surface:*client.wl.Surface, _output:?*client.wl.Output, _layer:Layer, _namespace:[*:0]const u8) !*client.zwlr.LayerSurfaceV1{const _proxy: *client.wl.Proxy = @ptrCast(_layer_shell_v1);var _args = [_]common.Argument{.{ .o = null },.{ .o = @ptrCast(_surface) },.{ .o = @ptrCast(_output) },.{ .u = switch (@typeInfo(Layer )) {
    .Enum => @as(u32, @intCast(@intFromEnum(_layer))),
    .Struct => @bitCast(_layer),
    else => unreachable,
 }},.{ .s = _namespace},};
return @ptrCast(try _proxy.marshalConstructor(0, &_args, client.zwlr.LayerSurfaceV1.getInterface()));}
pub fn destroy(_layer_shell_v1: *LayerShellV1) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_shell_v1);_proxy.marshal(1, null);_proxy.destroy();}
};
pub const LayerSurfaceV1 = opaque {
 pub const generated_version = 3;
 pub const getInterface = common.zwlr.layer_surface_v1.getInterface;pub const KeyboardInteractivity = common.zwlr.layer_surface_v1.KeyboardInteractivity;
pub const Error = common.zwlr.layer_surface_v1.Error;
pub const Anchor = common.zwlr.layer_surface_v1.Anchor;
pub fn setQueue(_layer_surface_v1: *LayerSurfaceV1, _queue: *client.wl.EventQueue) void {
    const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);
    _proxy.setQueue(_queue);
}pub const Event = union(enum) {configure: struct {serial:u32,width:u32,height:u32,},
closed: void,};
pub inline fn setListener(
    _layer_surface_v1: *LayerSurfaceV1,
    comptime T: type,
    _listener: *const fn (layer_surface_v1: *LayerSurfaceV1, event: Event, data: T) void,
    _data: T,
) void {
    const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);
    const _mut_data: ?*anyopaque = @ptrFromInt(@intFromPtr(_data));
    _proxy.addDispatcher(common.Dispatcher(LayerSurfaceV1, T).dispatcher, _listener, _mut_data);
}pub fn setSize(_layer_surface_v1: *LayerSurfaceV1, _width:u32, _height:u32) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .u = _width},.{ .u = _height},};
_proxy.marshal(0, &_args);}
pub fn setAnchor(_layer_surface_v1: *LayerSurfaceV1, _anchor:Anchor) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .u = switch (@typeInfo(Anchor )) {
    .Enum => @as(u32, @intCast(@intFromEnum(_anchor))),
    .Struct => @bitCast(_anchor),
    else => unreachable,
 }},};
_proxy.marshal(1, &_args);}
pub fn setExclusiveZone(_layer_surface_v1: *LayerSurfaceV1, _zone:i32) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .i = _zone},};
_proxy.marshal(2, &_args);}
pub fn setMargin(_layer_surface_v1: *LayerSurfaceV1, _top:i32, _right:i32, _bottom:i32, _left:i32) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .i = _top},.{ .i = _right},.{ .i = _bottom},.{ .i = _left},};
_proxy.marshal(3, &_args);}
pub fn setKeyboardInteractivity(_layer_surface_v1: *LayerSurfaceV1, _keyboard_interactivity:KeyboardInteractivity) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .u = switch (@typeInfo(KeyboardInteractivity )) {
    .Enum => @as(u32, @intCast(@intFromEnum(_keyboard_interactivity))),
    .Struct => @bitCast(_keyboard_interactivity),
    else => unreachable,
 }},};
_proxy.marshal(4, &_args);}
pub fn getPopup(_layer_surface_v1: *LayerSurfaceV1, _popup:*client.xdg.Popup) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .o = @ptrCast(_popup) },};
_proxy.marshal(5, &_args);}
pub fn ackConfigure(_layer_surface_v1: *LayerSurfaceV1, _serial:u32) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .u = _serial},};
_proxy.marshal(6, &_args);}
pub fn destroy(_layer_surface_v1: *LayerSurfaceV1) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);_proxy.marshal(7, null);_proxy.destroy();}
pub fn setLayer(_layer_surface_v1: *LayerSurfaceV1, _layer:common.zwlr.layer_shell_v1.Layer) void {const _proxy: *client.wl.Proxy = @ptrCast(_layer_surface_v1);var _args = [_]common.Argument{.{ .u = switch (@typeInfo(common.zwlr.layer_shell_v1.Layer )) {
    .Enum => @as(u32, @intCast(@intFromEnum(_layer))),
    .Struct => @bitCast(_layer),
    else => unreachable,
 }},};
_proxy.marshal(8, &_args);}
};
